import { CheckboxSOP } from '../../libappsop/checkboxsop';
import { FormSOP } from '../../libappsop/formsop';
import { ListSOP } from '../../libappsop/listsop';
import { DialogDummy } from '../dialogs/dialog.dummy';

export class FormBlendingPlanDetails extends FormSOP {
  public static readonly title = 'Blending Plan Details';
  public listNewSupply = new ListNewSupply();
  public cbFilterByBlendingPlan = new CheckboxSOP('CheckboxToggleButton');

  public constructor() {
    super('FormBlendingPlanDetails');
  }
}

export class ListNewSupply extends ListSOP<DialogDummy, ListNewSupplyColumn> {
  public static readonly title = 'Blending Plan Details (new supply)';

  public constructor() {
    super('ListNewSupply', new DialogDummy());

    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = { StockingPoint: '', Product: '', Unit: '', Start: '', Operation: '' };
  }
}

export interface ListNewSupplyColumn {
  StockingPoint?: string;
  Product?: string;
  Unit?: string;
  Routing?: string;
  Step?: string;
  Operation?: string;
  Start?: string;
  UnitOfMeasurement?: string;
  Quantity?: string;
}

// Although form (and not dialog), we create the interface so that spec script can use for step description (e.g calling StepDialog related method to use in "it")
export interface FormBlendingPlanDetailsFields {
  ToggleFilterByBlendingPlan: boolean;
}
